
#include <gccore.h>
#include <stdio.h>
#include <stdlib.h>

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

void sleep();
void usleep();
void sb();
void ibm();

int i;

#define CON_CLR() printf("\x1b[2J") // Console_Clear

int main(int argc, char **argv) {
	
	
	VIDEO_Init();
	PAD_Init();

	rmode = VIDEO_GetPreferredMode(NULL);
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	//console_init (xfb,0,10,640,576,640*VI_DISPLAY_PIX_SZ*4); 
	console_init(xfb,20,40,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);			
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	
	i=0;
	
	//ibm();

	while(1) {
		

		PAD_ScanPads(); u32 pressed = PAD_ButtonsDown(0);
		
		i++;
		
		printf("\x1b[0;0H");
		printf("LOOPING %u\n\n", i);
		
		kprintf("READING & WRITING 1 BYTE TO MEMCARD A ( LEFT )\n\n");
		
		sb();

		//if ( pressed & PAD_BUTTON_A ) {CON_CLR(); SYS_ResetSystem(SYS_RETURNTOMENU, 0, 0); }
		//if ( pressed & PAD_BUTTON_B ) {CON_CLR(); SYS_ResetSystem(SYS_HOTRESET, 0, 0); }
		//  REBOOTS TO NINTENDO IPL -- > SYS_ResetSystem(SYS_HOTRESET, 0, 0);
		
		if (SYS_ResetButtonDown()) 
			
			{ 
			
				CON_CLR(); 
				printf("RESET");
				console_init (xfb,0,10,640,576,640*VI_DISPLAY_PIX_SZ*4); 
				//console_init(xfb,20,40,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
				sleep(2);
			}
			
			
		if ( pressed & PAD_BUTTON_START ) exit(0);
		
		
		//if (pressed & PAD_BUTTON_A) {
		//void (*reload)() = (void(*)())0x81300000;                          
		//	reload();
		//}

		//VIDEO_WaitVSync();

	}

	return 0;
}


void sb() 

	{
		
		// -- READ DATA OUT CARD A
		// https://www.gc-forever.com/yagcd/chap5.html#sec5.9.1
	
		*((int*)0xCC006810) = 0xCCCCCCCC; // write some data A
		*((int*)0xCC006824) = 0xCCCCCCCC; // write some data
		*((int*)0xCC006838) = 0xCCCCCCCC; // write some data

		*((int*)0xCC00680C) = 5;   usleep(10); 	// WRITE 1 BYTE
		printf("0xCC006810 MEMCARD A DATA = %X\n\n", *((uint*)0xCC006810));

		
		//*((int*)0xCC006800) = 0;  
		*((int*)0xCC006800) = 128; usleep(1);  // CS CARD A
		*((int*)0xCC00680C) = 1;   usleep(10);  // READ 1 BYTE	
		printf("0xCC006810 MEMCARD A DATA = %X\n\n", *((uint*)0xCC006810));
        //usleep(125);
		
		printf("JOYSTOCK 1 DATA\n");	
		
		printf("0xCC006400 JOY0 = %X\n", *((uint*)0xCC006400));
		printf("0xCC006404 BUT1 = %X\n", *((uint*)0xCC006404));
		printf("0xCC006408 BUT2 = %X\n", *((uint*)0xCC006408));
		printf("0xCC006430 POLL = %X\n", *((uint*)0xCC006430));
		printf("0xCC006434 CONS = %X\n", *((uint*)0xCC006434));
		printf("0xCC006438 STAT = %X\n", *((uint*)0xCC006438));
		printf("0xCC006480 BUFF = %X\n", *((uint*)0xCC006480));
		
									

	}






















void ibm() 
	
{
	
	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM                             IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM     STARTING SOFTWARE       IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM        PLEASE WAIT...       IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM                             IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");	
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");
printf("IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM IBM\n");

	
//sleep(3);		

printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);
printf("                                                                           \n"); usleep(20000);


	
}
